Bug 1897544 - python-crypto fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats
Summary: python-crypto fails to build with Python 3.10: SystemError: PY_SSIZE_T_CLEAN ...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: python-crypto
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
high
Target Milestone: ---
Assignee: Paul Howarth
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: PYTHON3.10
TreeView+ depends on / blocked
 
Reported: 2020-11-13 11:56 UTC by Tomáš Hrnčiar
Modified: 2020-11-21 16:25 UTC (History)
4 users (show)

Fixed In Version: python-crypto-2.6.1-33.fc34
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2020-11-21 14:44:10 UTC
Type: Bug


Attachments (Terms of Use)

Description Tomáš Hrnčiar 2020-11-13 11:56:57 UTC
python-crypto fails to build with Python 3.10.0a2.

Traceback (most recent call last):
  File "build/lib.linux-x86_64-3.10/Crypto/SelfTest/Cipher/common.py", line 206, in runTest
    cipher = self.module.new(a2b_hex(self.key), self.module.MODE_CTR, counter=ctr)
  File "build/lib.linux-x86_64-3.10/Crypto/Cipher/AES.py", line 95, in new
    return AESCipher(key, *args, **kwargs)
  File "build/lib.linux-x86_64-3.10/Crypto/Cipher/AES.py", line 59, in __init__
    blockalgo.BlockAlgo.__init__(self, _AES, key, *args, **kwargs)
  File "build/lib.linux-x86_64-3.10/Crypto/Cipher/blockalgo.py", line 139, in __init__
    self._cipher = factory.new(key, *args, **kwargs)
SystemError: PY_SSIZE_T_CLEAN macro must be defined for '#' formats

https://docs.python.org/3.10/whatsnew/3.10.html#id2

The PY_SSIZE_T_CLEAN macro must now be defined to use PyArg_ParseTuple() and Py_BuildValue() formats which use #: es#, et#, s#, u#, y#, z#, U# and Z#. See Parsing arguments and building values and the PEP 353.
https://docs.python.org/3.10/c-api/arg.html#arg-parsing
https://www.python.org/dev/peps/pep-0353
https://bugs.python.org/issue40943

For the build logs, see:
https://copr-be.cloud.fedoraproject.org/results/@python/python3.10/fedora-rawhide-x86_64/01757388-python-crypto/

For all our attempts to build python-crypto with Python 3.10, see:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/package/python-crypto/

Testing and mass rebuild of packages is happening in copr. You can follow these instructions to test locally in mock if your package builds with Python 3.10:
https://copr.fedorainfracloud.org/coprs/g/python/python3.10/

Let us know here if you have any questions.

Python 3.10 will be included in Fedora 35. To make that update smoother, we're building Fedora packages with early pre-releases of Python 3.10.
A build failure prevents us from testing all dependent packages (transitive [Build]Requires), so if this package is required a lot, it's important for us to get it fixed soon.
We'd appreciate help from the people who know this package best, but if you don't want to work on this now, let us know so we can try to work around it on our side.

Comment 1 Paul Howarth 2020-11-13 14:20:22 UTC
python-crypto is no longer maintained upstream but there is an active fork, python-pycryptodomex, which is also included in Fedora, and when that is fixed for this issue, I should be able to use the same fix for python-crypto.

Of course it would be better if python-crypto users in Fedora migrated to python-pycryptodomex and then we could get rid of python-crypto altogether.

Comment 2 Paul Howarth 2020-11-13 15:09:14 UTC
Hmm, looks like this code was refactored out of python-pycryptodomex a long time ago so I'll have to think again about what to do about this.

Comment 3 Miro Hrončok 2020-11-20 09:06:00 UTC
Looks like ansible does not build in our copr because pytohn3-crypto is missing. I'll check if the build dependency is really needed, because on runtime, it uses cryptography.

Comment 4 Miro Hrončok 2020-11-20 09:20:55 UTC
Ansible has tests that use this :(

We could skip those, but I am not sure if safe. Bumping the severity here, ansible is important. Please let us know if you need help figuring out the fix.

Comment 5 Paul Howarth 2020-11-21 14:44:10 UTC
Should be fixed in python-crypto-2.6.1-33.fc34

Comment 6 Miro Hrončok 2020-11-21 16:25:20 UTC
Thank You, Paul!


Note You need to log in before you can comment on or make changes to this bug.